﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace IK
{
    class DistanceMetricMap : RangedMetricMap<double>
    {
        public DistanceMetricMap(double min, double max)
            : base(min, max)
        { }

        public override Color Colourise(Result result)
        {
            if (!result.Reached) {
                return Color.Black;
            } else {
                double value = Maths.CLerp(result.Distance, Min, Max);
                return ColorHelper.HSVtoRGB((1.0 - value) * 240.0, 1, 1);
            }
        }
    }
}
