﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;

namespace IK
{
    abstract class MetricMap
    {
        public Image Generate(Workspace workspace)
        {
            // Create a bitmap the same size as the workspace
            Bitmap bitmap = new Bitmap(workspace.Size, workspace.Size, PixelFormat.Format32bppArgb);

            // Wrap the pixel operations in a fastpixel object
            using (FastPixel fastpixel = new FastPixel(bitmap)) {
                fastpixel.Lock();


                // Colourise each result in the workspace
                for (int y = 0; y < workspace.Size; y++) {
                    for (int x = 0; x < workspace.Size; x++) {
                        fastpixel.SetPixel(x, y, Colourise(workspace.getTarget(x, y).Result));
                    }
                }


                fastpixel.Unlock(true);
            }

            return bitmap;
        }

        public abstract Color Colourise(Result result);
    }
}
