﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;

namespace IK
{
    static class Program
    {
        static int Main(string[] args)
        {
            PerformanceTimer timer = new PerformanceTimer();


            // Global settings
            int num_links = 5;          // n
            int max_iterations = 10;    // i
            double tolerance = 0.01;    // e

            // Plot size
            int size = 300;


            // Create the chain
            Chain chain = new CCDChain(num_links);

            // Create the workspace
            Workspace workspace = new Workspace(size);


            // Plot to a buffer
            timer.Start();
            workspace.Cover(chain, max_iterations, tolerance);
            timer.Stop();
            Console.WriteLine("Time {0:0.###} sec", timer.Duration);


            // Measure the buffer statistics
            //Statistics stats = Statistics.Measure(workspace);
            //Console.WriteLine("Coverage {0:0.0%}", stats.Coverage);


            // Render the buffer to an image
            MetricMap metricMap = new IterationsMetricMap(0,max_iterations);
            Image bitmap = metricMap.Generate(workspace);

            // Display the image
            ImageViewer.ShowImageAsForm(bitmap);


            //using (Form1 form = new Form1(solver, links)) { form.ShowDialog(); }


            Console.Write("Press any key to exit ...");
            Console.ReadKey();

            return Environment.ExitCode;
        }
    }
}
